
      .include "jaguar.inc"
      .include "graphics.inc"
      .include "./u235se/u235se.inc"

      .extern modinit
          
    .globl fbx
	  .globl fby
	  .globl topvbl
                   
      .68000
      .text

; *********************************************************
;
; Tools
;

; ------------------------------------------------
;  TRACE str (MACRO)
        .macro  TRACE 
        move.l  a0,-(sp)
        lea .\~,a0
        jsr skunkCONSOLEWRITE
        .data ; put the string data
.\~: dc.b \1,0 ; in the data segment
        .text ; switch back to TEXT
        move.l  (sp)+,a0
        .endm  

; ------------------------------------------------
;  Trace (C function)
; IN: (long) ptr to string
_Trace::
        move.l  4(sp),a0
        jsr skunkCONSOLEWRITE
        rts
        
; ------------------------------------------------
;  TraceDec (C function)
; IN: (long) number to display
;     (long) number of digits
_TraceDec::
        move.l  4(sp),d0
        move.l  8(sp),d1
        lea   hexbuff,a0
        move.l  d1,-(sp)
        move.l  a0,-(sp)
        move.l  d0,-(sp)
        jsr _ConvertDec
        move.l  (sp)+,d0
        move.l  (sp)+,a0
        addq.l  #4,sp        
        jsr skunkCONSOLEWRITE
        rts    

; ------------------------------------------------
;  TraceHex (C function)
; IN: (long) number to display
_TraceHex::
        move.l  4(sp),d0        
        lea   hexbuff,a0        
        move.l  a0,-(sp)
        move.l  d0,-(sp)
        jsr _ConvertHex
        move.l  (sp)+,d0
        move.l  (sp)+,a0                
        jsr skunkCONSOLEWRITE
        rts               

; ------------------------------------------------
;  CloseConsole (C function)
_CloseConsole::   
        move.w  consoleclose,d0
        tst.w d0
        bne.s .endfunc
        jsr skunkCONSOLECLOSE
        move.w  #-1,consoleclose
.endfunc:        
        rts
        
             
; ------------------------------------------------
; WaitGPU (C interface)
; IN: void
; OUT: void
_WaitGPU::
.loop:
		move.l  G_CTRL,d0   		; Wait for write.
		andi.l  #$1,d0
		bne 	.loop		
    rts
      
            
; ------------------------------------------------
; ConvertHex (C interface)
;  Convert integer number to string in hex notation
; IN: (long) number
;     (long) ptr to buffer. Must be at least 9 bytes long.
; OUT: void
_ConvertHex::
          move.l  4(sp),d0  ; number
          move.l  8(sp),a0  ; buffer     
          move.l  d2,-(sp)
          
          move.l  a0,d1     ; test null pointer   
          tst.l   d1
          beq.s   .convend
          
          clr.l   d1
          adda.w  #9,a0   ; Position pointer to the end of the string.
          clr.b   -(a0)   ; null terminated string
          move.w  #7,d2   ; 8 digits
.loop:    move.b  d0,d1
          andi.b  #$F,d1
          cmpi.b  #$A,d1
          bge.s   .hexdigit
.decdigit:
          addi.b  #$30,d1 ; '0'
          bra.s   .next
.hexdigit:
          addi.b  #$37,d1    ; 'A'-10
.next:    move.b  d1,-(a0)  ; add digits in reverse order.
          lsr.l   #4,d0
          dbf     d2,.loop
 .convend:
          move.l (sp)+,d2    
          rts

; ------------------------------------------------
; ConvertDec (C interface)
;  Convert integer number to string in decinaml notation
; Maximum absoluted number handled: 655359
; IN: (long) number
;     (long) ptr to buffer. Buffer must be at least 13 bytes long.
;     (long) digits count
; OUT: void
_ConvertDec::
        move.l  4(sp),d0
        move.l  8(sp),a0
        move.l  12(sp),d1
        movem.l  d2-d4,-(sp)
        tst.l   d1
        beq.s   .endfunc
        
        cmpi.w  #10,d1
        blo.s   .digitsOK
        moveq.l #10,d1
.digitsOK:
        tst.l   d0
        bge.s   .signOK
        neg.l   d0
        move.b  #'-',(a0)+        
.signOK:
        moveq.l #10,d2
        lea (a0,d1),a0
        move.b  #0,(a0) ; // Null terminator
        subq.w  #1,d1        
.loop:  clr.l   d3
        divu.w  d2,d0
        move.w  d0,d3
        swap    d0
        add.b   #'0',d0
        move.b  d0,-(a0)
        move.l  d3,d0
        dbf   d1,.loop
.endfunc:        
        movem.l  (sp)+,d2-d4
        rts

 
 ; -----------------------------------------------
 ; memset64 (C interface)
 ; IN: (long) ptr dest (phrase aligned)
 ;      (long) pat1
 ;      (long) pat2
 ;      (long) len
 ; OUT: void
 _Memset64::         
        move.l  4(sp),a0
        move.l  8(sp),d0
        move.l  12(sp),d1
        move.l  16(sp),a1        
        move.l  d2,-(sp)
        
        move.l  a0,d2 ; check null pointer
        tst.l   d2
        beq.s   endmemset64
        
        clr.l   d2
        move.l  a1,d2
        lsr.l   #2,d2
        andi.l  #$FFFF,d2
        
        move.l  a0,A1_BASE
        move.l  #PITCH1|PIXEL32|XADDPHR,A1_FLAGS
        move.l  d1,B_PATD
        move.l  d0,B_PATD+4
        clr.l   d0
        move.l  d0,A1_PIXEL
        ori.l   #(1<<16),d2
        move.l  d2,B_COUNT
        move.l  #PATDSEL|LFU_REPLACE,B_CMD
 .loop:    
        move.l  B_CMD,d0
        andi.w  #$1,d0
        beq.s   .loop
 
endmemset64:               
        move.l  (sp)+,d2
        rts
        
; -----------------------------------------------
; memcopy64 (C interface)
; IN: (long) ptr dest (phrase aligned)
;      (long) ptr src (phrase aligned)
;      (long) len
; OUT: void
_Memcopy64::
      move.l  4(sp),a0
      move.l  8(sp),a1
      move.l  12(sp),d1
      
      move.l  a0,d0
      tst.l d0
      beq.s endmemcopy64
      move.l  a1,d0
      tst.l d0
      beq.s endmemcopy64
      
      clr.l d0  
      asr.l #2,d1  
      move.l  #PITCH1|PIXEL32|XADDPHR,A2_FLAGS
      move.l  a1,A2_BASE
      move.l  d0,A2_PIXEL     
      move.l  #PITCH1|PIXEL32|XADDPHR,A1_FLAGS
      move.l  a0,A1_BASE
      move.l  d0,A1_PIXEL
      or.l    #(1<<16),d1
      move.l  d1,B_COUNT
      move.l  #SRCEN|LFU_REPLACE,B_CMD
 .loop:    
        move.l  B_CMD,d0
        andi.w  #$1,d0
        beq.s   .loop
              
endmemcopy64:      
      rts 

; ------------------------------------------------
; srand (C interface)
;  Initiate pseudo random number generator
; IN: (long) seed
; OUT: void
_srand::
      move.l  4(sp),d0
      move.l  d0,d1
      ror.l   #3,d0      
      rol.l   #7,d1
      add.l   d0,d1
      add.l   #593441861,d1
      move.l  d1,seednumber
      rts


; ------------------------------------------------
; rand (C interface)
;  Generate pseudo random number.
; IN: (void)
; OUT: (int) pseudo random number
_rand::
      move.l  seednumber,d0  
      move.l  d0,d1 
      andi.l  #31,d1         
      add.l   #167,d0
      rol.l   #5,d0
      add.l   #7883,d0
      rol.l   #7,d0
      add.l   #1943911,d0
      rol.l   #4,d0
      add.l   #613651349,d0
      rol.l   d1,d0
      move.l  d0,seednumber
      rts
      
; ------------------------------------------------
; DivS (C interface)
;  Signed division of 32 bit dividend by 16 bit divisor
; IN: (int) dividend
;     (int) divisor
; OUT: (int) quotient      
_DivS:: 
      move.l  4(sp),d0
      move.l  8(sp),d1
      divs.w  d1,d0
      ext.l   d0      
      rts
      
; ------------------------------------------------
; DivU (C interface)
;  Unsigned division of 32 bit dividend by 16 bit divisor
; IN: (int) dividend
;     (int) divisor
; OUT: (int) quotient      
_DivU:: 
      move.l  4(sp),d0
      move.l  8(sp),d1
      divu.w  d1,d0
      andi.l  #$FFFF,d0      
      rts    
      
; ------------------------------------------------
; DivUmod (C interface)
;  Unsigned division of 32 bit dividend by 16 bit divisor
; IN: (int) dividend
;     (int) divisor
;     (int) ptr to hold modulo result
; OUT: (int) quotient      
_DivUmod:: 
      move.l  4(sp),d0
      move.l  8(sp),d1
      move.l  12(sp),a0      
      divu.w  d1,d0
      move.l  d0,d1
      swap    d1
      andi.l  #$FFFF,d1 ; modulo
      move.l  d1,(a0)
      andi.l  #$FFFF,d0 ; quotient            
      rts    
 
; ------------------------------------------------
; GetSystemType (C interface)
;   Tell whether it is a PAL or a NTSC system.
; OUT: (int) 0 = PAL
;           1 = NTSC    
_GetSystemType::
  	move.w  CONFIG,d0      		 ; Also is joystick register
  	andi.w  #VIDTYPE,d0    		 ; 0 = PAL, 1 = NTSC
  	lsr.l  #4,d0  		
    rts   
         
; ------------------------------------------------
; strlen (C interface)
;   Tell the number of characters in a zero terminated string
; INT: (int) ptr to string
; OUT: (int) number of character, not including zero.
         
_strlen::
    move.l  4(sp),d0
    tst.l d0
    beq.s .nullstring
    move.l  d0,a0
    clr.l d0
.loop:
    addq.l  #1,d0
    move.b  (a0)+,d1
    tst.b   d1
    bne.s .loop
    
    subq.l  #1,d0
    rts

.nullstring:
    clr.l d0
    rts
    
; *********************************************************
;
; Lib Draw
;
             
; ------------------------------------------------
; LibDrawInit (C interface)
; IN:   (long) ptr video mem
;       (long) pixels size + width (as defined in JAGUAR.INC))
;       (long) height
; OUT: void

_LibDrawInit:: 
          move.l  4(sp),d0    ; pointer to video memory
          move.l  8(sp),d1  ;  Blitter flags: pixels size + width(blitter small float)
          move.w  14(sp),vidh  ; height
          
          move.l  d0,vidmem        
          move.w  #1,blitmode ; PIXEL mode
          
          move.l  d1,d0
          andi.l  #%111000,d0   ; extract pixel size
          tst.l   d0            ; Test if a pixel size is selected (PIXEL1 can't be used)
          bne.s   SetUserPixelSize
          move.w  #PIXEL16,blitpixsz  ; Default pixel size: 16bits
          bra.s ComputeScreenWidth
          
SetUserPixelSize:
          move.w  d0,blitpixsz
 
ComputeScreenWidth:
          move.l  d1,d0
          andi.l  #$7E00,d0     ; extract blit width
          move.l  d0,vidblitwid
                    
          ; Convert width in blitter small float notation to integer number
          ; Blitter constant
          ; 14 13 12 11 10 09
          ; e3 e2 e1 e0 m1 m0
          ; %1.m1m0 * 2 ^ (e3e2e1e0)
          ; = %1m1m0 * 2 ^ (e3e2e1e0 - 2)
          lsr.l   #8,d0
          lsr.l   #1,d0
          move.l  d0,d1
          andi.w  #%11,d1 ; build integer mantissa
          ori.w   #%100,d1  ; %0.m1m0 -> %1m1m0
          lsr.l   #2,d0   ; extract exponent
          subq.w  #2,d0   ; Mantissa shifted << 2. Therefore substract 2 to exponent.
          lsl.w   d0,d1   
          move.w  d1,vidw

          clr.l fontpt
                             
          rts


; ------------------------------------------------
; SelectFont (C interface)
; IN: (long) ptr to font
;     (long) w
;     (long) h
_SelectFont::
      move.l  4(sp),a0
      move.l  8(sp),d0
      move.l  12(sp),d1
      
      move.l  a0,fontpt
      move.w  d0,fontw
      move.w  d1,fonth
      
      rts

; ------------------------------------------------
; SelectFont (C interface)
; IN: (long) blit mode (as defined in JAGUAR.INC)
_SetBlitMode::
      move.l  4(sp),d0
      swap    d0
      move.w  d0,blitmode
      rts
            
; ------------------------------------------------
; DrawText (C interface)
; In: (long) X, (long) Y, (long) string address
; Out: void
_DrawText::
          move.w  6(sp),CurX  ; X
          move.w  10(sp),CurY  ; Y
          move.l  12(sp),a0 ; address          
          movem.l  d2-d4,-(sp)
          
          move.l  a0,d0
          tst.l   d0
          beq     .endDrawText ; NULL pointer
                
          move.l  fontpt,d0
          tst.l   d0
          beq     .endDrawText
          move.l  d0,a1
              
          clr.l   d3
          move.w  fonth,d3
          
          clr.l   d0
          move.w  fontw,d0
          neg.w   d0
          andi.l  #$FFFF,d0        
          ori.l   #1<<16,d0          
          move.l  d0,A1_STEP
          
          clr.l   d0
          move.w  d3,d0
          swap    d0
          or.w    fontw,d0
          move.l  d0,d4
                           
          move.l  a1,A2_BASE
          clr.l   d0
          move.w  blitmode,d0
          swap    d0
          move.l  d0,d1 ; save blit mode
          or.l    #PITCH1|WID8,d0
          or.w    blitpixsz,d0
          move.l  d0,A2_FLAGS
          move.l  vidmem,A1_BASE
          move.l  #PITCH1,d0
          or.l    d1,d0   ; blit mode
          or.l    vidblitwid,d0    
          or.w    blitpixsz,d0                
          move.l  d0,A1_FLAGS
          
          clr.l   d1
          clr.l   d2
          move.w  CurX,d1
          move.w  CurY,d2
            
.loop:
          clr.l   d0  
          move.b  (a0)+,d0
          beq     .endDrawText
 
          subi.w  #32,d0  ; First charater is SPACE (ASCII 32).
          cmpi.w  #95,d0          
          bhi.s   .step  ; Character not in font: skip it.
          
          mulu.w  d3,d0
          swap    d0
          move.l  d0,A2_PIXEL
          
          clr.l   d0
          move.w  d2,d0   ; d2: cursor Y
          swap    d0
          or.w    d1,d0   ; d1: cursor X
          move.l  d0,A1_PIXEL          
          move.l  d4,B_COUNT
          move.l  #SRCEN|LFU_REPLACE|UPDA1,B_CMD
.step:          
          add.w   fontw,d1                    
          bra     .loop
.endDrawText:  
          movem.l  (sp)+,d2-d4        
          rts
          

; ------------------------------------------------
; DrawHex (C interface)
; In: (long) X, (long) Y, (long) number
; Out: void
_DrawHex::  move.l  4(sp),d0
            move.l  8(sp),d1
            move.l  12(sp),a0
            movem.l  d2-d4,-(sp)
            move.l  a0,d2
            move.l  d0,d3
            move.l  d1,d4
            
            lea   hexbuff,a0
            move.l  a0,-(sp)
            move.l  d2,-(sp)
            jsr _ConvertHex
            move.l  (sp)+,d2
            move.l  (sp)+,a0
            
            move.l  a0,-(sp)
            move.l  d4,-(sp)
            move.l  d3,-(sp)
            jsr _DrawText
            adda.l  #12,sp
            
            movem.l  (sp)+,d2-d4
            rts

; ------------------------------------------------
; DrawDec (C interface)
; In: (long) X, (long) Y, (long) number, (long) digits counts
; Out: void
_DrawDec::
            move.l  4(sp),d0
            move.l  8(sp),d1
            move.l  12(sp),a0
            move.l  16(sp),a1
            movem.l  d2-d4,-(sp)
            move.l  a0,d2
            move.l  d0,d3
            move.l  d1,d4
            
            lea   hexbuff,a0
            move.l  a1,-(sp)
            move.l  a0,-(sp)
            move.l  d2,-(sp)
            jsr _ConvertDec
            move.l  (sp)+,d2
            move.l  (sp)+,a0
            addq.l  #4,sp
            
            move.l  a0,-(sp)
            move.l  d4,-(sp)
            move.l  d3,-(sp)
            jsr _DrawText
            adda.l  #12,sp
            
            movem.l  (sp)+,d2-d4
            rts

; ------------------------------------------------
; BitBlit64 (C interface)
; In: (long) Xd, (long) Yd, (long), (long)Wblits (blitter flags), (long)pixel count, (long)addrs
; Out: void
_BitBlit64::
          move.w 8+2(sp),d0
          swap d0          
          move.w  4+2(sp),d0 ; Xd
          move.l  12(sp),d1 ; Wblits          
          move.l  16(sp),a1 ; count         
          move.l  20(sp),a0 ; addr source
          
          movem.l  d2-d3,-(sp)                    
          
          clr.l   d3  
          move.l  d1,d3
          lsr.l   #8,d3
          lsr.l   #1,d3
          move.l  d3,d2
          andi.w  #%11,d2 ; build integer mantissa
          ori.w   #%100,d2  ; %0.m1m0 -> %1m1m0
          lsr.l   #2,d3   ; extract exponent
          subq.w  #2,d3   ; Mantissa shifted << 2. Therefore substract 2 to exponent.
          lsl.w   d3,d2   
                              
          neg.w   d2
          andi.l  #$FFFF,d2
          ori.l   #1<<16,d2
          move.l  d2,A1_STEP
                    
          ori.l   #PITCH1|PIXEL16|XADDPHR,d1
          move.l  d1,A2_FLAGS                    
          clr.l d1
          move.l  a0,A2_BASE
          move.l  d1,A2_PIXEL
          
          move.l  #PITCH1|PIXEL16|XADDPHR,d2
          or.l   vidblitwid,d2                    
          move.l  d2,A1_FLAGS          
          move.l  vidmem,A1_BASE
          move.l  d0,A1_PIXEL
                              
          move.l  a1,B_COUNT
          move.l  #SRCEN|LFU_REPLACE|UPDA1,B_CMD
          
          movem.l (sp)+,d2-d3
          rts
        
; *********************************************************
;
; Hardware bitmap management
;


; ------------------------------------------------
;  Init Jaguar
; IN: d0: framebuffer width
;     d1: framebuffer height
InitJaguar::
  		movem.l d0-d6/a0-a1,-(sp)
  		
      move.w  #$FFFF,VI       	; disable video interrupts
      	
  		move.w  d0,fbw
  		move.w  d1,fbh
  		move.w  d2,videomode
  		move.l  d3,customvit
  		
  		clr.w   topvbl  		  		
  		clr.l   _ActiveBitmapArray
    
    ;	move.l	#0,G_FLAGS	; Init GPU
	   ; move.l	#0,D_FLAGS	; Init DSP
		  move.l  #$70007,G_END		; big-endian mode
		  move.l  #$70007,D_END
		  move.w	#$35cc,MEMCON2
		  
  		move.w  CONFIG,d0      		 ; Also is joystick register
  		andi.w  #VIDTYPE,d0    		 ; 0 = PAL, 1 = NTSC
  		beq.s 	palvals
  
  		move.w  #NTSC_HMID,d2
  		move.w  #NTSC_WIDTH,d0
  
  		move.w  #NTSC_VMID,d6
  		move.w  #NTSC_HEIGHT,d4
  
  		bra.s 	calc_vals
palvals:
  		move.w  #PAL_HMID,d2
  		move.w  #PAL_WIDTH,d0  ; PAL_WIDTH
  
  		move.w  #PAL_VMID,d6
  		move.w  #PAL_HEIGHT,d4
  
calc_vals:
  		move.w  d0,width
  		move.w  d4,height
  
  		move.w  d0,d1
  		asr 	#1,d1         	 	; Width/2
  
  		sub.w   d1,d2         	  	; Mid - Width/2
  		add.w   #4,d2         	  	; (Mid - Width/2)+4
  
  		sub.w   #1,d1         	  	; Width/2 - 1
  		ori.w   #$400,d1      	  	; (Width/2 - 1)|$400
  		
  		move.w  d1,a_hde
  		move.w  d1,HDE
  
  		move.w  d2,a_hdb
  		move.w  d2,HDB1
  		move.w  d2,HDB2
  
  		move.w  d6,d5
  		sub.w   d4,d5
  		
  		move.w  d5,a_vdb
  
  		add.w   d4,d6
  		move.w  d6,a_vde
  		move.w  a_vdb,VDB
  		move.w  #$FFFF,VDE
  			
  		move.l  #$FF000000,BORD1        	; Red border
  		move.w  #$FF,BG           	; Init line buffer to blue
  		
; Center frame buffer      	
  		move.w  width,d4            	; Get width in clocks
		  lsr.w   #2,d4               	; /4 Pixel Divisor
		  sub.w   fbw,d4
		  lsr.w   #1,d4
		  move.w  d4,fbx
		  
		  move.w  height,d4           	; Center bitmap vertically
		  sub.w   fbh,d4
      add.w   a_vdb,d4
      lsr.w   #1,d4		
		  andi.w  #$FFFE,d4
      move.w  d4,fby 

; Install  interupt routine 	
      move.l  customvit,d0
      tst.l   d0
      beq.s   setupvideo_it
      move.l  d0,LEVEL0
      bra.s   video_it_timing
       
setupvideo_it:      
      move.l  #ManageBitmaps,LEVEL0	; Install 68K LEVEL0 handler

video_it_timing:
      move.w  a_vde,d0        	; Must be ODD
      ori.w   #1,d0
      move.w  d0,VI
            
      move.w  #C_VIDENA|C_GPUENA,INT1  	; Enable video & GPU interrupts

      move.w  sr,d0
      and.w   #$F8FF,d0       	; Lower 68k IPL to allow
      move.w  d0,sr           	; interrupts
		        
      move.w  videomode,d0
      ori.w   #PWIDTH4|BGEN|CSYNC|VIDEN,d0
      move.w  d0,VMODE
      
 ; Initialize U235 sound engine
      move.w	#2048,d0
      lea		 dspcode,a0
	    move.l	#D_RAM,a1
.loop:
      move.l	(a0)+,(a1)+
      dbra.w	 d0,.loop
          		
      lea		  U235SE_playback_rate,a0
      move.l	#U235SE_24KHZ,(a0)
      lea		  U235SE_playback_period,a0
      move.l	#U235SE_24KHZ_PERIOD,(a0)

      move.w	#$100,JOYSTICK		; enable sound
                    
      ; enable DSP
      move.l	#D_RAM,D_PC			; Set up D_PC (DSP's program counter)
      move.l	#RISCGO,D_CTRL		; Go, baby go!
 
; Init sample bank
      move.l  #CSplSz*N_Spl,-(sp)
      clr.l   -(sp)
      clr.l   -(sp)
      pea     splbank
      jsr     _Memset64
      lea     16(sp),sp
         
      lea playlist,a0
      move.l  a0,a1
      
      move.l  #splbank,d2
      andi.b  #$F0,d2
      or.b    #$b,d2    ; select sample bank
      move.l  d2,(a0)+
      
      clr.l   (a0)+
      
      lea U235SE_sfxplaylist_ptr,a0
      move.l  a1,(a0)
    
; Init track vol and freq
      lea curvol,a0
      lea curfreq,a1
      move.w  #7,d0
.loop2:
      move.w  #64,(a0)+
      move.w  #12000,(a1)+
      dbf d0,.loop2
      
; Clear joypads vars
      clr.l   _joy1edge
      clr.l   _joy2edge
      clr.l   _joy1cur
      clr.l   _joy2cur

; Init skunk
      jsr skunkNOP
      jsr skunkNOP
      move.w  #0,consoleclose     
      TRACE "InitJaguar\n"

  		movem.l (sp)+,d0-d6/a0-a1
  		rts        

; ------------------------------------------------
;  ManageBitmaps
;   Video interrupts routine
 ;   .extern _vidmem

    .text
ManageBitmaps:  
    movem.l  d0-d3/d7/a0-a1,-(sp)    
    move.w  INT1,d0
    btst.l  #1,d0
    beq.s     NotAGPUInterrupt
          
    move.w  #C_GPUCLR|C_VIDENA|C_GPUENA,INT1  ; clear GPU interrupt
    move.w  #$0,INT2
    movem.l  (sp)+,d0-d3/d7/a0-a1
    rte
    
NotAGPUInterrupt:   
    btst.l  #0,d0
    bne.s   VideoInterrupt    
    movem.l  (sp)+,d0-d3/d7/a0-a1 
    rte
   
VideoInterrupt:	
    move.l  _ActiveBitmapArray,d0
    tst.l   d0
    beq    .NoBitmapArray
    
    move.l  d0,a1
    move.l  CBitmapArrayCount(a1),d7
    tst.w   d7
    beq    .NoBitmapArray
    subq.w  #1,d7  
    move.l  CBitmapArrayPt(a1),d0
    tst.l   d0
    beq    .NoBitmapArray
    move.l  d0,a1
    move.w  fbx,d2
    move.w  fby,d3
.loop:
    move.l  CBitmapPtDL(a1),a0
    move.l  CBitmapObj(a1),d0     ; 63 - 32
    andi.l  #$7FFF,d0           ; Clear DATA
    move.l  CBitmapAddr(a1),d1  ; Update DATA
    andi.b  #$F8,d1           ; Bitmap must be phrase aligned.
    lsl.l   #8,d1
    or.l    d1,d0
    move.l  d0,(a0)   
    move.l  CBitmapObj+4(a1),d0   ; 31 - 0
    andi.w  #$C007,d0   ; clear YPOS
    move.w  CBitmapY(a1),d1  ; Update YPOS
    add.w   d3,d1       ; add framebuffer y pos
    andi.w  #$7FF,d1    ; YPOS is 11 bits
    lsl.l   #4,d1     ; 3 + 1: YPOS is in half-lines.
    or.w    d1,d0   
    move.l  d0,4(a0)
    move.w  14(a0),d0 ; Get low 16 bits of 2nd phrase
    andi.w  #$F000,d0 ; clear XPOS
    move.w  CBitmapX(a1),d1 ; update XPOS
    add.w   d2,d1     ; add framebuffer x pos
    andi.w  #$FFF,d1  ; XPOS is 12 bits
    or.w    d1,d0
    move.w  d0,14(a0)
    lea   CBitmapSz(a1),a1
    dbf    d7,.loop
	
    move.l  _ActiveBitmapArray,a1
		move.l  CBitmapArrayDL(a1),d0
		tst.l   d0
		beq.s   .NoBitmapArray
    move.l  d0,OLP
.NoBitmapArray: 
	  add.l	#1,_ticks		; Increment ticks semaphore   
	  move.w  #$FFFF,topvbl
		move.w  #C_VIDCLR|C_VIDENA|C_GPUENA,INT1  ; Clear video interupt
		move.w  #$0,INT2

		movem.l  (sp)+,d0-d3/d7/a0-a1
		rte

; ------------------------------------------------
;  WaitVBL (C interface)
_WaitVBL::
    lea topvbl,a0
    clr.w (a0)
    stop #$2000    
.loop:
    tst.w (a0)
    beq.s .loop
        
    rts

; ------------------------------------------------
;  MakeBitmap (C interface)
; IN: (long) Ptr to CBitmap
;     (long) Ptr to data
;     (long) X
;     (long) Y
;     (long) W
;     (long) H
;     (long) flags
_MakeBitmap::
    move.l  4(sp),a0  
    move.l  8(sp),a1
    move.w  14(sp),d0
    swap  d0
    move.w  18(sp),d0
    move.w  22(sp),d1
    swap  d1
    move.w  26(sp),d1
        
    move.l  d2,-(sp)
    move.l  a0,d2
    tst.l   d2
    beq.s   .endfunc
    
    move.l  28+4(sp),d2
    
    move.l  a1,CBitmapAddr(a0)
    move.w  d0,CBitmapY(a0)
    swap  d0
    move.w  d0,CBitmapX(a0)
    move.w  d1,CBitmapH(a0)
    swap  d1
    move.w  d1,CBitmapW(a0)
    move.w  d2,CBitmapFlags(a0)
    clr.w   d0
    move.w  d0,CBitmapCsFlags(a0)
    
.endfunc:
    move.l  (sp)+,d2
    rts

; ------------------------------------------------
;  MakeBitmap8b (C interface)
; IN: (long) Ptr to CBitmap
;     (long) Ptr to data
;     (long) X
;     (long) Y
;     (long) W
;     (long) H
;     (long) flags
_MakeBitmap8b::
    move.l  4(sp),a0  
    move.l  8(sp),a1
    move.w  14(sp),d0
    swap  d0
    move.w  18(sp),d0
    move.w  22(sp),d1
    swap  d1
    move.w  26(sp),d1
        
    move.l  d2,-(sp)
    move.l  a0,d2
    tst.l   d2
    beq.s   .endfunc
    
    move.l  28+4(sp),d2
    
    move.l  a1,CBitmapAddr(a0)
    move.w  d0,CBitmapY(a0)
    swap  d0
    move.w  d0,CBitmapX(a0)
    move.w  d1,CBitmapH(a0)
    swap  d1
    move.w  d1,CBitmapW(a0)
    move.w  d2,CBitmapFlags(a0)
    clr.w   d0
    bset.l  #DEPTH8_FLAG,d0
    move.w  d0,CBitmapCsFlags(a0)
.endfunc:
    move.l  (sp)+,d2
    rts    
    
; ------------------------------------------------
;  InitBitmapArray (C interface)
; IN: (long) Ptr to CBitmapArray
;     (long) Ptr to display list
;     (long) Ptr to bitmaps
;     (int)  bitmap count
; OUT: void
_InitBitmapArray::
    move.l  4(sp),a0
    move.l  8(sp),d0
    move.l  12(sp),a1
    move.l  16(sp),d1
    move.l  d2,-(sp)
    move.l  a0,d2
    tst.l   d2
    beq   .endfunc
    tst.l   d0
    beq   .endfunc
    tst.l   d1
    beq   .endfunc
    swap  d0
    move.l  d0,CBitmapArrayDL(a0)
    move.l  a1,CBitmapArrayPt(a0)
    move.l  d1,CBitmapArrayCount(a0)
    
    swap  d0
    move.l  d0,a0 ; a0: pointer to DL
    move.l  d1,d2
    subq.l  #1,d2
    lsl.l #4,d1   ; compute DL size: n bitmaps*16 + 24 (2 branch objects + stop object)
    addi.l  #24,d1
    
    move.l  d1,-(sp)
    move.l  a0,-(sp)
    jsr   _InitDL
    move.l  (sp)+,a0
    addq.l  #4,sp
    add.l d0,a0

.loop:
    move.l  a1,-(sp)
    move.l  a0,-(sp)
    jsr   _AddBitmap
    move.l  (sp)+,a0
    move.l  (sp)+,a1
    add.l d0,a0
    lea CBitmapSz(a1),a1
    dbf   d2,.loop
    
    move.l  a0,-(sp)
    jsr _AddStopObject
    addq.l  #4,sp
    
.endfunc:
    move.l  (sp)+,d2
    rts
      
; ------------------------------------------------
;  InitDL (C interface)
;   Init a display list: add branch objects.
; IN: (long) Ptr to display list
;     (long) display list size in bytes
; OUT: DL offset
_InitDL:: move.l  4(sp),a0
          move.l  8(sp),d0
          movem.l d2-d4,-(sp)
          
       		move.l  a0,d2           	; Copy DL pointer
      
          subq.l  #8,d0 
      		add.l   d0,d2  	; Address of STOP object
      		move.l	d2,d3			; Copy for low half
      
      		lsr.l	#8,d2			; Shift high half into place
      		lsr.l	#3,d2
      		
      		swap	d3			; Place low half correctly
      		clr.w	d3
      		lsl.l	#5,d3

; Write first BRANCH object (branch if YPOS > a_vde )
      		clr.l   d0
      		move.l  #(BRANCHOBJ|O_BRLT),d1  ; $4000 = VC < YPOS
      		or.l	d2,d0			; Do LINK overlay
      		or.l	d3,d1
      								
      		move.w  a_vde,d4                ; for YPOS
      		lsl.w   #3,d4                   ; Make it bits 13-3
      		or.w    d4,d1
      
      		move.l	d0,(a0)+
      		move.l	d1,(a0)+

; Write second branch object (branch if YPOS < a_vdb)
      		andi.l  #$FF000007,d1           ; Mask off CC and YPOS
      		ori.l   #O_BRGT,d1      	; $8000 = VC > YPOS
      		move.w  a_vdb,d4                ; for YPOS
      		lsl.w   #3,d4                   ; Make it bits 13-3
      		or.w    d4,d1
      
      		move.l	d0,(a0)+
      		move.l	d1,(a0)+         
                    
          movem.l (sp)+,d2-d4
          moveq.l  #16,d0
          rts
          
                  
; ------------------------------------------------
;  AddBitmap (C interface) 
;   Pack a bitmap structure into a display list object
; IN:  (long) Ptr to display list bitmap obj
;     (long) Ptr to a CBitmap structure
;             Info to fill in the structure:
;                CBitmapAddr,CBitmapX,CBitmapY,CBitmapW,CBitmapH
; OUT: offset
_AddBitmap::  move.l  4(sp),a0
              move.l  8(sp),a1
              movem.l  d2-d3,-(sp)
                            
              move.l  a0,CBitmapPtDL(a1)  ; Save ptr to object
              
; 1st phrase
              clr.l d0  ; 63 - 32
              clr.l d1  ; 31 - 0
              clr.l d2
              move.w  CBitmapY(a1),d2   ; pack YPOS
              add.w   fby,d2
              andi.w  #$7FF,d2         ; YPOS is 11 bits
              lsl.l #4,d2           ; 3 + 1 because YPOS is in half-lines.
              or.l  d2,d1
              clr.l d2
              move.w  CBitmapH(a1),d2   ; pack HEIGHT
              andi.w  #$3FF,d2         ; HEIGHT is 10 bits
              lsl.l #6,d2
              lsl.l #8,d2
              or.l  d2,d1
              
              move.l  a0,d2             ; pack LINK (next object is 16 bytes away)
              addi.l  #16,d2
              lsr.l   #3,d2           ; skip lower 3 bits
              move.l  d2,d3
              swap    d2
              clr.w   d2
              lsl.l   #8,d2
              or.l    d2,d1
              lsr.l   #8,d3
              or.l    d3,d0
              
              move.l  CBitmapAddr(a1),d2
              andi.b  #$F8,d2
              lsl.l   #8,d2
              or.l    d2,d0
              
              move.l  d0,(a0)+
              move.l  d1,(a0)+
              move.l  d0,CBitmapObj(a1)
              move.l  d1,CBitmapObj+4(a1)

; second phrase
              clr.l   d0
              clr.l   d1
              clr.l   d2
              move.w  CBitmapX(a1),d2
              add.w   fbx,d2
              andi.w  #$FFF,d2    ; XPOS is 12 bits
              move.w  d2,d1
              move.w  CBitmapW(a1),d2
              move.w  CBitmapCsFlags(a1),d0
              btst.l  #DEPTH8_FLAG,d0 ; 8bit bitmaps?
              beq.s   .BitmapDepth16              
              ori.l   #O_NOGAP|O_DEPTH8,d1
              lsr.w   #1,d2     ; 8bit pixels: half the width in phrases
              bra.s   .SetWidthInPhrase
.BitmapDepth16:
              ori.l   #O_NOGAP|O_DEPTH16,d1
.SetWidthInPhrase:
              clr.l   d0
              andi.b  #$FC,d2   ; data width in phrases 
              move.l  d2,d3
              swap    d2
              or.l    d2,d1     ; data width in phrases at bit 18.
              lsl.l   #8,d2
              lsl.l   #2,d2
              or.l    d2,d1     ; image width at bit 28
              lsr.l   #6,d3
              or.l    d3,d0     ; rest of image width at bit 32           
              or.w    CBitmapFlags(a1),d0
              move.l  d0,(a0)+
              move.l  d1,(a0)+
                  
              movem.l  (sp)+,d2-d3
              moveq.l #16,d0
              rts

; ------------------------------------------------
;  AddStopObject (C interface) 
; IN:(long) Ptr to display list
; OUT: (long) offset
_AddStopObject::
        move.l  4(sp),a0
        clr.l (a0)+
        move.l  #(STOPOBJ|O_STOPINTS),(a0)+
        moveq.l #8,d0
                    
        rts
        
; ------------------------------------------------
;  Test bitmap collision (C interface) 
;   set bitmap flag if collision
; IN: (long) ptr to small bitmap 
;     (long) ptr to bitmap group
;      (int) number of bitmaps in group
; OUT: void
_TestBitmapCollision::
        move.l  4(sp),a0
        move.l  8(sp),a1
        move.l  12(sp),d0
        movem.l  d2-d6,-(sp)
        
        tst.l   d0
        beq     .NoData
        move.l  d0,d6
        subq.l  #1,d6
        
        move.l  a0,d0
        tst.l   d0
        beq    .NoData
        move.l  a1,d0
        tst.l   d0
        beq    .NoData
       
        bclr.b  #COLLIDE_FLAG,CBitmapCsFlags+1(a0) 
        btst.b  #ACTIVE_COLLISION_FLAG,CBitmapCsFlags+1(a0)
        beq     .NoData
          
.loop:        
        btst.b  #ACTIVE_COLLISION_FLAG,CBitmapCsFlags+1(a1)
        beq     .endloop
     
        move.w  CBitmapX(a0),d0 ; Xmin1
        move.w  CBitmapX(a1),d2 ; Xmin2
        move.w  d0,d1
        move.w  d2,d3
        add.w   CBitmapW(a0),d1 ; Xmax1
        add.w   CBitmapW(a1),d3 ; Xmax2
        subq.w  #1,d1
        subq.w  #1,d3
        
        cmp.w   d0,d3     ;  Xmin1 > Xmax2: no collision
        blt.s   .noCollision
        cmp.w   d1,d2     ;  Xmax1 < Xmin2: no collision
        bge.s   .noCollision
               
        move.w  CBitmapY(a0),d0 ; Ymin1
        move.w  CBitmapY(a1),d2 ; Ymin2
        move.w  d0,d1
        move.w  d2,d3
        add.w   CBitmapH(a0),d1 ; Ymax1
        add.w   CBitmapH(a1),d3 ; Ymax2
        subq.w  #1,d1
        subq.w  #1,d3        
        
        cmp.w   d0,d3     ;  Ymin1 > Ymax2: no collision
        blt.s   .noCollision
        cmp.w   d1,d2     ;  Ymax1 < Ymin2: no collision
        bge.s   .noCollision
        
        bset.b  #COLLIDE_FLAG,CBitmapCsFlags+1(a0)
        bset.b  #COLLIDE_FLAG,CBitmapCsFlags+1(a1)        
        bra.s  .endloop

.noCollision:
        bclr.b  #COLLIDE_FLAG,CBitmapCsFlags+1(a1)
        ; do no clear probe bitmap, it could have collision with other bitmaps.
.endloop: 
        lea CBitmapSz(a1),a1      
        dbf     d6,.loop
        bra.s   .endfunc
                
.NoData:
        clr.l   d0
        
.endfunc:        
        movem.l (sp)+,d2-d6
        rts

testCollision:
        sub.w   d2,d0
        blt.s   .NoCollision
        sub.w   d3,d1
        blt.s   .NoCollision
        cmp.w   d4,d0
        bge.s   .NoCollision
        cmp.w   d5,d1
        bge.s   .NoCollision
        st.b    d0
        rts
.NoCollision:
        clr.l   d0
        rts
        
; ------------------------------------------------
;  MakeAnim (C interface)
; IN: (long) ptr to CAnim
;     (long) ptr to CBitmap
;     (long) increment
;     (long) steps
;     (long) ticks    
; OUT: void 
_MakeAnim::
        move.l  4(sp),a0    ; CAnim
        move.l  8(sp),a1    ; CBitmap
        move.w  14(sp),d0   ; increment
        swap  d0
        move.w  18(sp),d0   ; steps
        move.w  22(sp),d1   ; ticks
        
        move.l  d2,-(sp)
        move.l  a0,d2
        tst.l   d2
        beq.s  .endfunc
        move.l  a1,d2
        tst.l   d2
        beq.s  .endfunc
        
        move.l  a1,CAnimBitmapPt(a0)
        move.l  CBitmapAddr(a1),CAnimBasePt(a0)
        move.w  d0,CAnimSteps(a0)
        swap  d0
        move.w  d0,CAnimIncrement(a0)
        move.w  d1,CAnimTicks(a0)
        clr.w   CAnimType(a0)
        clr.w   CAnimStepCounter(a0)
        clr.w   CAnimTickCounter(a0)
           
.endfunc:
        move.l  (sp)+,d2        
        rts
 
; ------------------------------------------------
;  UpdateAnim (C interface)
; IN: (long) ptr to CAnim
;     (long) count 
; OUT: void
_UpdateAnim::
        move.l  4(sp),a0
        move.l  8(sp),d1 
        movem.l  d2-d3/a2,-(sp)
        move.l  a0,d0
        tst.l   d0
        beq.s   .endfunc

        tst.l   d1
        beq.s   .endfunc
        move.l  d1,d3
        subq.l  #1,d3
.loop:      
        move.w  CAnimStepCounter(a0),d0
        move.w  CAnimIncrement(a0),d1
        move.l  CAnimBasePt(a0),a2
        move.l  CAnimBitmapPt(a0),a1
        mulu.w  d0,d1
        adda.l  d1,a2
        move.l  a2,CBitmapAddr(a1)
        
        move.w  CAnimTickCounter(a0),d0
        move.w  CAnimTicks(a0),d1
        addq.w  #1,d0
        cmp.w   d0,d1
        bgt.s   .writetick      
        clr.w   d0
                
        move.w  CAnimStepCounter(a0),d2
        move.w  CAnimSteps(a0),d1
        addq.w  #1,d2
        cmp.w   d2,d1
        bgt.s   .writestep
        clr.w   d2   

.writestep:        
        move.w  d2,CAnimStepCounter(a0)
.writetick:
        move.w  d0,CAnimTickCounter(a0)
        
        lea CAnimSz(a0),a0
        dbf   d3,.loop
        
.endfunc:        
        movem.l  (sp)+,d2-d3/a2
        rts
        
; ------------------------------------------------
;  ResetAnim (C interface)
; IN: (long) ptr to CAnim
;     (long) count 
; OUT: void
_ResetAnim::
        move.l  4(sp),a0
        move.l  8(sp),d1
        move.l  a0,d0
        tst.l   d0
        beq.s  .endfunc
        
        tst.l   d1
        beq.s  .endfunc
        
        subq.l  #1,d1        
.loop:
        move.l  CAnimBitmapPt(a0),a1
        move.l  CAnimBasePt(a0),CBitmapAddr(a1)
        clr.w   CAnimStepCounter(a0)
        clr.w   CAnimTickCounter(a0)
        lea CAnimSz(a0),a0
        dbf d1,.loop
        
.endfunc:
        rts


; *********************************************************
;
; Joypads management
;
 
; ------------------------------------------------
;  ReadJoypads (C interface) 
;   Read both joypads and update state variables.
;
; Store a bitmask of the current state of the joysticks in joy1cur
; and joy2cur. The variables joy1edge and joy2edge stores a state
; bitmap of new key 'changed' events since the last time
; ReadJoypads was called.
;
_ReadJoypads:
		move.l	d2,-(sp)

		lea	JOYSTICK,a0

		move.l	#$f0fffffc,d1		; d1 = Joypad data mask
		moveq.l	#-1,d2		 	; d2 = Cumulative joypad reading

		move.w	#$81fe,(a0)
		move.l	(a0),d0		 	; Read joypad, pause button, A button
		or.l	d1,d0			; Mask off unused bits
		ror.l	#4,d0
		and.l	d0,d2			; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
		move.w	#$81fd,(a0)
		move.l	(a0),d0			; Read *741 keys, B button
		or.l	d1,d0			; Mask off unused bits
		ror.l	#8,d0
		and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxxxxxxx xxxxxxxx
		move.w	#$81fb,(a0)
		move.l	(a0),d0			; Read 2580 keys, C button
		or.l	d1,d0			; Mask off unused bits
		rol.l	#6,d0
		rol.l	#6,d0
		and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxxx 2580xxxx
		move.w	#$81f7,(a0)
		move.l	(a0),d0			; Read 369# keys, Option button
		or.l	d1,d0			; Mask off unused bits
		rol.l	#8,d0
		and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== inputs active low

		moveq.l	#-1,d1
		eor.l	d2,d1			; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high

		move.l	_joy1cur,d0		; old joycur needed for determining the new joyedge
		move.l	d1,_joy1cur		; Current joypad reading stored into joycur
		eor.l	d1,d0
	
		move.l	d0,_joy1edge		;joypad, buttons, keys that were just changed

;scan for player 2
		move.l	#$0ffffff3,d1		; d1 = Joypad data mask
		moveq.l	#-1,d2			; d2 = Cumulative joypad reading

		move.w	#$817f,(a0)
		move.l	(a0),d0			; Read joypad, pause button, A button
		or.l	d1,d0			; Mask off unused bits
		rol.b	#2,d0			; note the size of rol
		ror.l	#8,d0
		and.l	d0,d2			; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
		move.w	#$81bf,(a0)
		move.l	(a0),d0			; Read *741 keys, B button
		or.l	d1,d0			; Mask off unused bits
		rol.b	#2,d0			; note the size of rol
		ror.l	#8,d0
		ror.l	#4,d0
		and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxxxxxxx xxxxxxxx
		move.w	#$81df,(a0)
		move.l	(a0),d0			; Read 2580 keys, C button
		or.l	d1,d0			; Mask off unused bits
		rol.b	#2,d0			; note the size of rol
		rol.l	#8,d0
		and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxxx 2580xxxx
		move.w	#$81ef,(a0)
		move.l	(a0),d0			; Read 369# keys, Option button
		or.l	d1,d0			; Mask off unused bits
		rol.b	#2,d0			; note the size of rol
		rol.l	#4,d0
		and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== inputs active low

		moveq.l	#-1,d1
		eor.l	d2,d1			; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high

		move.l	_joy2cur,d0		; old joycur needed for determining the new joyedge
		move.l	d1,_joy2cur		; Current joypad reading stored into joycur
		eor.l	d1,d0

		move.l	d0,_joy2edge		;joypad, buttons, keys that were just changed

		move.l	(sp)+,d2
		rts
 
; *********************************************************
;
; U235 sound engine C wrapper
;        

; ------------------------------------------------
;  SetSample (C interface)
; IN: (long) index in bank
;     (long) ptr to sample (8bit PCM signed)
;     (long) ptr to sample end
; OUT: (int) 0: sample added. Otherwise not in bank.
_SetSample::
        move.l  4(sp),d0
        move.l  8(sp),a0
        move.l  12(sp),a1        
        movem.l  d2/a2,-(sp)
        
        cmpi.w  #N_Spl-1,d0
        bhi.s   .badendfunc
        
        mulu.w  #CSplSz,d0
        lea     splbank,a2
        lea     (a2,d0),a2
        
        move.l  a0,CSplAddr(a2)
        move.l  a1,CSplEnd(a2)
        clr.l   CSplROFF(a2)
        clr.l   CSplRLEN(a2)
        move.l  #63,CSplSettings(a2)
        move.l  #8000,CSplFreq(a2)
        
        clr.l   d0        
        bra.s   .endfunc
                
.badendfunc:
        moveq.l #-1,d0
        
.endfunc:
        movem.l  (sp)+,d2/a2
        moveq.l #-1,d0
        rts
        
; ------------------------------------------------
;  SetSampleWithLoop (C interface)
; IN: (long) index in bank
;     (long) ptr to sample (8bit PCM signed)
;     (long) ptr to sample end
;     (long) ptr to looping point
; OUT: (int) 0: sample added. Otherwise not in bank.
_SetSampleWithLoop::
        move.l  4(sp),d0
        move.l  8(sp),a0
        move.l  12(sp),a1
        move.l  16(sp),d1        
        movem.l  d2/a2,-(sp)
        
        cmpi.w  #N_Spl-1,d0
        bhi.s   .badendfunc
        
        mulu.w  #CSplSz,d0
        lea     splbank,a2
        lea     (a2,d0),a2
        
        move.l  a0,CSplAddr(a2)
        move.l  a1,CSplEnd(a2)
        move.l  d1,CSplROFF(a2)
        move.l  a1,CSplRLEN(a2)
        move.l  #63,CSplSettings(a2)
        move.l  #8000,CSplFreq(a2)
        
        clr.l   d0        
        bra.s   .endfunc
                
.badendfunc:
        moveq.l #-1,d0
        
.endfunc:
        movem.l  (sp)+,d2/a2
        moveq.l #-1,d0
        rts        

; ------------------------------------------------
;  PlaySample (C interface)
;  IN:  (long) channel
;       (long) index
; OUT: void
_PlaySample::
        move.l  4(sp),d1
        move.l  8(sp),d0
        movem.l  a2-a3/d2,-(sp)
        
        lea playlist,a0
        move.l  a0,a1
        
        move.l  #splbank,d2
        andi.b  #$F0,d2
        or.b    #$b,d2    ; select sample bank
        move.l  d2,(a0)+
        
        clr.l   d2
        
        andi.l  #N_Spl-1,d0   ; max index: N_Spl must be a power of two
        andi.l  #7,d1     ; max channel: 7
        move.l  d1,d2     ; save channel in d2
                   
        lsl.l   #4,d0   ; select spl number
        or.l    d0,d1   ; spl + channel
        lsl.l   #4,d1   ; make room for command
        
        lea curfreq,a3
        clr.l   d0
        add.l d2,d2
        move.w  (a3,d2),d0 ; get freq for next command
        swap  d0
        or.l    d0,d1    ; set freq
        or.b    #$4,d1  ; play sample at freq        
        move.l  d1,(a0)+
                
        clr.l d0
        clr.l d1
        lea curvol,a2
        move.w  (a2,d2),d0  ; get volume
        lsl.l #3,d2
        lsl.l #8,d0 ; volume in data x
        or.b  d2,d0 ; channel
        ori.b #$3,d0  ; set volume
        move.l  d0,(a0)+  
          
        clr.l   (a0)   ; playlist end
        
        lea U235SE_sfxplaylist_ptr,a0
        move.l  a1,(a0)
                
        movem.l  (sp)+,a2-a3/d2
        rts

; ------------------------------------------------
;  PlaySampleDoubleChan (C interface)
;  IN:  (long) channel
;       (long) index
; OUT: void
_PlaySampleDoubleChan::
        move.l  4(sp),d1
        move.l  8(sp),d0
        movem.l  a2-a3/d2-d4,-(sp)
        
        lea playlist,a0
        move.l  a0,a1
        
        move.l  #splbank,d2
        andi.b  #$F0,d2
        or.b    #$b,d2    ; select sample bank
        move.l  d2,(a0)+
      
        clr.l   d2
        
        andi.l  #N_Spl-1,d0   ; max index: N_Spl must be a power of two
        andi.l  #$7,d1     ; max channel: 7
        move.l  d1,d2     ; save channel in d2
        move.l  d2,d3
        addq.l  #1,d3
        andi.b  #$7,d3    ; next channel in d3
        move.l  d3,d4     ;  save next channel in d4
        
        lsl.l   #4,d0   ; select spl number
        or.l    d0,d1   ; spl + channel
        lsl.l   #4,d1   ; make room for command  
        lea curfreq,a3
        clr.l d0
        add.l d2,d2
        move.w  (a3,d2),d0
        swap  d0
        or.l  d0,d1               
        or.b    #$4,d1  ; play sample        
        move.l  d1,(a0)+
           
        andi.l #$FFFFFF0F,d1 ; clear channel info
        lsl.l #4,d3
        or.b  d3,d1   ; add next channel info
        move.l  d1,(a0)+ ; play sample in next channel
             
        clr.l d0
        clr.l d1
        lea curvol,a2        
        move.w  (a2,d2),d0  ; get volume        
        lsl.l #3,d2
        lsl.l #8,d0 ; volume in data x
        or.b  d2,d0 ; channel
        ori.b #$3,d0  ; set volume
        move.l  d0,(a0)+  
         
        clr.l d0
        clr.l d1
        add.l d4,d4
        move.w  (a2,d4),d0  ; get volume        
        lsl.l #8,d0 ; volume in data x
        or.b  d3,d0 ; channel
        ori.b #$3,d0  ; set volume
        move.l  d0,(a0)+  
                
        clr.l   (a0)   ; playlist end
        
        lea U235SE_sfxplaylist_ptr,a0
        move.l  a1,(a0)
                
        movem.l  (sp)+,a2-a3/d2-d4
        rts

; ------------------------------------------------
;  SetFreq (C interface)
;  IN:  (long) channel
;       (long) freq
; OUT: void
_SetFreq::
        move.l  4(sp),d0
        move.l  8(sp),d1
        
        lea curfreq,a0
        andi.l  #$7,d0
        add.l d0,d0
        move.w  d1,(a0,d0)
                  
        rts

; ------------------------------------------------
;  SetVol (C interface)
;  IN:  (long) channel
;       (long) vol
; OUT: void
_SetVol::
        move.l  4(sp),d0
        move.l  8(sp),d1
        
        lea curvol,a0
        andi.l  #$7,d0
        add.l d0,d0
        move.w  d1,(a0,d0)
     
        rts

; ------------------------------------------------ 
; ApplyFreqVolChanges (C interface) 
;  Apply the changes by SetVol and SetFreq to channels 4 - 8
_ApplyFreqVolChanges::
        movem.l  d2-d3/a2/a3,-(sp)
        lea playlist,a0
        move.l  a0,a1
        
        move.l  #splbank,d2
        andi.b  #$F0,d2
        or.b    #$b,d2    ; select sample bank
        move.l  d2,(a0)+
        
        clr.l d2
        move.w  #3,d3        
        lea curvol+(4*2),a2 ; volume per channel
        lea curfreq+(4*2),a3  ; frequency per channel        
        move.w  #4<<4,d2   ; Start at channel 4
.loop:  clr.l  d0
        move.w  (a3)+,d0 ; read cur freq
        swap  d0        ; add cur freq       
        or.w  d2,d0     ; add channel number
        ori.b #$7,d0    ; command adjust playback rate
        move.l  d0,(a0)+
        
        clr.l d0
        move.w  (a2)+,d0  ; read cur vol
        andi.b  #$FF,d0
        lsl.l   #8,d0 ; add cur vol
        or.w    d2,d0 ; add channel number
        ori.b #$3,d0  ; set volume
        move.l  d0,(a0)+
        
        
        addi.l  #1<<4,d2  ; next channel
        dbf d3,.loop
        
        clr.l (a0) ; playlist end 
        
        lea U235SE_sfxplaylist_ptr,a0
        move.l  a1,(a0)
        
        movem.l (sp)+,d2-d3/a2/a3
        rts        
        
; ------------------------------------------------
;  ChangeSampleSign (C interface)
;  IN:  (long) index
_ChangeSampleSign::
        move.l  4(sp),d0
        cmpi.b  #N_Spl-1,d0
        bhi.s   .endfunc
        
        mulu.w  #CSplSz,d0
        lea   splbank,a0
        lea   (a0,d0),a0
        move.l  CSplAddr(a0),a1
        move.l  CSplEnd(a0),d1
        sub.l   a1,d1
        blt.s   .endfunc
.loop:  move.b  (a1),d0
        add.b #128,d0
        move.b  d0,(a1)+
        dbf d1,.loop
.endfunc:
        rts
        

; ------------------------------------------------
;  InitModule (C interface)
;  IN:  (long) ptr to mod
_InitModule::
        move.l  4(sp),a0
        movem.l d2/d5/d7/a3,-(sp)
        jsr modinit
        movem.l (sp)+,d2/d5/d7/a3
        rts

; ------------------------------------------------
;  PlayModule (C interface)
_PlayModule::
        move.l  #U235SE_PLAYSTEREO,U235SE_playmod
        rts
        
; ------------------------------------------------
; StopModule (C interface)
_StopModule::
        move.l  #U235SE_NOMOD,U235SE_playmod
        rts
        
; *********************************************************
;   Skunkboard communication sources        

        .include "skunk.s"
      
        
        .bss

        .long

_ActiveBitmapArray: .ds.l 1  ; pointer to active bitmap array      
vidmem:    .ds.l 1    ; pointer to video memory
vidblitwid:  .ds.l 1   ; blitter constant for width (small float notation)
blitpixsz:    .ds.w 1 ; blitter pixel size
blitmode:     .ds.w 1 ; blit mode (PHR, PIX, INC)
vidw:     .ds.w 1
vidh:     .ds.w 1

CurX:     .ds.w 1
CurY:     .ds.w 1  

_ticks:    .ds.l   1
a_hdb:    .ds.w   1
a_hde:    .ds.w   1
a_vdb:    .ds.w   1
a_vde:    .ds.w   1
width:    .ds.w   1
height:   .ds.w   1
fbx:  .ds.w 1
fby:  .ds.w 1
fbw:  .ds.w 1
fbh:  .ds.w 1
videomode:  .ds.w 1
topvbl: .ds.w 1
consoleclose: .ds.w 1
hexbuff:  .ds.b 16

      .long
seednumber: .ds.l   1
_joy1edge:	.ds.l		1
_joy1cur:	  .ds.l		1
_joy2edge:	.ds.l		1
_joy2cur:	  .ds.l		1
customvit:  .ds.l   1
fontpt:   .ds.l 1
fontw:    .ds.w 1
fonth:    .ds.w 1

      .dphrase
splbank:    .ds.l  CSplSz*N_Spl
playlist:   .ds.l  32
curvol:   .ds.w  8
curfreq:  .ds.w  8

      .end
    